<script setup lang="ts">
import AForm from '@/components/AForm/index.vue'
import { FormConfigType } from '@/components/AForm/type'
import { ToolbarConfigType } from '@/components/AToolbar/type'
import { ColumnConfigType } from '@/components/ATable/type'
import { StrAnyObj, StrAnyObjArr } from '@/typings'
import { useHandleData } from '@/utils/useHandleData'
import {
  getPageApi,
  getDetailApi,
  addApi,
  editApi,
  deleteApi
} from '@/api/business/capital/account'
import { getPageApi as getCorporationPageApi } from '@/api/business/corporation/corporation'

const queryRef = ref<InstanceType<typeof AForm>>()
const formRef = ref<InstanceType<typeof AForm>>()

const showQuery = ref<boolean>(true)
const selectKeys = ref<string[]>([])
const pageTotal = ref<number>(0)

const queryData = ref<StrAnyObj>({ pageNum: 1, pageSize: 10 })
const tableData = ref<StrAnyObjArr>([])
const formData = ref<StrAnyObj>({ amount: 0 })

const dialogTitle = ref<string>('')
const dialogVisible = ref<boolean>(false)

const queryConfig: FormConfigType[] = [
  {
    type: 'select',
    prop: 'corporationId',
    label: '归属公司',
    keyName: 'id',
    labelName: 'name',
    async option() {
      const data = await getCorporationPageApi({ searchAll: true })
      return data.records
    }
  },
  {
    type: 'input',
    prop: 'accountAlias',
    label: '账户别名'
  },
  {
    type: 'input',
    prop: 'depositBank',
    label: '开户银行'
  },
  {
    type: 'input',
    prop: 'accountName',
    label: '账户名'
  },
  {
    type: 'input',
    prop: 'account',
    label: '账号'
  },
  {
    type: 'input',
    prop: 'correspondentNumber',
    label: '联行号'
  }
]

const toolbarConfig: ToolbarConfigType[] = [
  {
    common: 'search',
    click() {
      queryData.value.pageNum = 1
      getPage()
    }
  },
  {
    common: 'reset',
    click() {
      queryRef.value?.resetFields()
      getPage()
    }
  },
  {
    common: 'add',
    click() {
      dialogVisible.value = true
      dialogTitle.value = '新增'
    }
  },
  {
    common: 'delete',
    disabled() {
      return selectKeys.value.length == 0
    },
    click() {
      handleRemove(selectKeys.value)
    }
  }
]

const columnConfig: ColumnConfigType[] = [
  {
    prop: 'corporationName',
    label: '归属公司'
  },
  {
    prop: 'accountAlias',
    label: '账户别名'
  },
  {
    prop: 'depositBank',
    label: '开户银行'
  },
  {
    prop: 'accountName',
    label: '账户名'
  },
  {
    prop: 'account',
    label: '账号'
  },
  {
    prop: 'correspondentNumber',
    label: '联行号'
  },
  {
    prop: 'amount',
    label: '账户余额'
  },
  {
    width: 250,
    handleConfig: [
      {
        common: 'update',
        click(row) {
          dialogVisible.value = true
          dialogTitle.value = '编辑'
          getDetailApi({ id: row.id }).then((resp: StrAnyObj) => {
            formData.value = resp
          })
        }
      },
      {
        common: 'delete',
        click(row) {
          handleRemove([row.id])
        }
      }
    ]
  }
]

const formConfig: FormConfigType[] = [
  {
    type: 'select',
    prop: 'corporationId',
    label: '归属公司',
    async option() {
      const data = await getCorporationPageApi({ searchAll: true })
      return data.records
    },
    keyName: 'id',
    labelName: 'name',
    rule: [{ required: true, message: '归属公司不能为空', trigger: 'blur' }]
  },
  {
    type: 'input',
    prop: 'accountAlias',
    label: '账户别名',
    rule: [{ required: true, message: '账户别名不能为空', trigger: 'blur' }]
  },
  {
    type: 'inputNumber',
    prop: 'amount',
    label: '初始金额',
    min: 0.00,
    precision: 2,
    if() {
        return formData.value.id == null
    },
    rule: [{ required: true, message: '初始金额不能为空', trigger: 'blur' }]
  },
  {
    type: 'input',
    prop: 'depositBank',
    label: '开户银行'
  },
  {
    type: 'input',
    prop: 'accountName',
    label: '账户名'
  },
  {
    type: 'input',
    prop: 'account',
    label: '账号'
  },
  {
    type: 'input',
    prop: 'correspondentNumber',
    label: '联行号'
  },
  {
    type: 'input',
    prop: 'remark',
    itemType: 'textarea',
    rows: 5,
    label: '备注'
  }
]

onMounted(() => {
  getPage()
})

function getPage() {
  getPageApi(queryData.value).then((resp) => {
    tableData.value = resp.records
    pageTotal.value = resp.total
  })
}

function tableSelectionChange(item: StrAnyObjArr) {
  selectKeys.value = item.map((item) => item.id)
}

function formSubmit() {
  formRef.value?.validate(() => {
    if (formData.value.id) {
      editApi(formData.value).then(() => {
        dialogVisible.value = false
        ElMessage.success('修改成功')
        getPage()
      })
    } else {
      addApi(formData.value).then(() => {
        dialogVisible.value = false
        ElMessage.success('新增成功')
        getPage()
      })
    }
  })
}

function formClosed() {
  formRef.value?.resetFields()
}

function handleRemove(idList: string[]) {
  useHandleData('是否确认删除？', () => {
    deleteApi({ idList }).then(() => {
      ElMessage.success('删除成功')
      getPage()
    })
  })
}
</script>

<template>
  <div>
    <el-card v-if="showQuery">
      <a-form ref="queryRef" v-model="queryData" :config="queryConfig" :span="6"> </a-form>
    </el-card>

    <a-table
      selection
      :data="tableData"
      :page-total="pageTotal"
      :toolbar-config="toolbarConfig"
      :column-config="columnConfig"
      v-model:showQuery="showQuery"
      v-model:page-num="queryData.pageNum"
      v-model:page-size="queryData.pageSize"
      @page-num-change="getPage"
      @page-size-change="getPage"
      @selection-change="tableSelectionChange"
    >
    </a-table>

    <a-dialog
      v-model="dialogVisible"
      :title="dialogTitle"
      @submit="formSubmit"
      @closed="formClosed"
    >
      <a-form ref="formRef" v-model="formData" :config="formConfig" :span="24"> </a-form>
    </a-dialog>
  </div>
</template>
